#include <language/utils/BinaryOperatorRegisterForR.hpp>

#include <language/utils/BasicBinaryOperatorRegisterComparisonOf.hpp>

void
BinaryOperatorRegisterForR::_register_comparisons()
{
  BasicBinaryOperatorRegisterComparisonOf<bool, double>{};
  BasicBinaryOperatorRegisterComparisonOf<double, bool>{};

  BasicBinaryOperatorRegisterComparisonOf<uint64_t, double>{};
  BasicBinaryOperatorRegisterComparisonOf<double, uint64_t>{};

  BasicBinaryOperatorRegisterComparisonOf<int64_t, double>{};
  BasicBinaryOperatorRegisterComparisonOf<double, int64_t>{};

  BasicBinaryOperatorRegisterComparisonOf<double, double>{};
}

template <typename OperatorT>
void
BinaryOperatorRegisterForR::_register_arithmetic()
{
  OperatorRepository& repository = OperatorRepository::instance();

  repository.addBinaryOperator<OperatorT>(
    std::make_shared<BinaryOperatorProcessorBuilder<OperatorT, double, double, bool>>());
  repository.addBinaryOperator<OperatorT>(
    std::make_shared<BinaryOperatorProcessorBuilder<OperatorT, double, bool, double>>());

  repository.addBinaryOperator<OperatorT>(
    std::make_shared<BinaryOperatorProcessorBuilder<OperatorT, double, double, uint64_t>>());
  repository.addBinaryOperator<OperatorT>(
    std::make_shared<BinaryOperatorProcessorBuilder<OperatorT, double, uint64_t, double_t>>());

  repository.addBinaryOperator<OperatorT>(
    std::make_shared<BinaryOperatorProcessorBuilder<OperatorT, double, double, int64_t>>());
  repository.addBinaryOperator<OperatorT>(
    std::make_shared<BinaryOperatorProcessorBuilder<OperatorT, double, int64_t, double_t>>());

  repository.addBinaryOperator<OperatorT>(
    std::make_shared<BinaryOperatorProcessorBuilder<OperatorT, double, double, double>>());
}

BinaryOperatorRegisterForR::BinaryOperatorRegisterForR()
{
  this->_register_comparisons();
  this->_register_arithmetic<language::plus_op>();
  this->_register_arithmetic<language::minus_op>();
  this->_register_arithmetic<language::multiply_op>();
  this->_register_arithmetic<language::divide_op>();
}
